var contextMenuBackground = new function() {
    var imageContextMenu, imageAutosearchContextMenu, inputContextMenu;
    this.showImageContextMenu = function() {
        this.hideImageContextMenu();
        imageContextMenu = chrome.contextMenus.create({
            id: "1",
            title: chrome.i18n.getMessage("markImageTitle"),
            contexts: ["image"],
            onclick: this.markAsCaptchaRelated.bind(null, "image", false)
        })
    };
    this.hideImageContextMenu = function() {
        if (imageContextMenu) {
            chrome.contextMenus.remove(imageContextMenu)
        }
    };
    this.showInputContextMenu = function() {
        this.hideInputContextMenu();
        inputContextMenu = chrome.contextMenus.create({
            id: "2",
            title: chrome.i18n.getMessage("markInputTitle"),
            contexts: ["editable"],
            onclick: this.markAsCaptchaRelated.bind(null, "input", false)
        })
    };
    this.hideInputContextMenu = function() {
        if (inputContextMenu) {
            chrome.contextMenus.remove(inputContextMenu)
        }
    };
    this.showImageAutosearchContextMenu = function() {
        this.hideImageAutosearchContextMenu();
        imageAutosearchContextMenu = chrome.contextMenus.create({
            id: "3",
            title: chrome.i18n.getMessage("imageAutosearchTitle"),
            contexts: ["editable"],
            onclick: this.markAsCaptchaRelated.bind(null, "input", true)
        })
    };
    this.hideImageAutosearchContextMenu = function() {
        if (imageAutosearchContextMenu) {
            chrome.contextMenus.remove(imageAutosearchContextMenu)
        }
    };
    this.markAsCaptchaRelated = function(elementType, autosearch, info, tab) {
        chrome.tabs.sendMessage(tab.id, {
            type: "contextMenuClickedOnCaptchaRelated",
            elementType: elementType,
            autosearch: autosearch
        }, {
            frameId: info.frameId
        }, function() {})
    }
};