var globalStatus = {
    profile_user_info: null,
    plugin_version: chrome.app && chrome.app.getDetails && chrome.app.getDetails().version ? chrome.app.getDetails().version : chrome.runtime && chrome.runtime.getManifest() && chrome.runtime.getManifest().version ? chrome.runtime.getManifest().version : "0.001",
    plugin_last_version_data: null
};
var oldGlobalStatusJSON = null;
var predefinedHostnameSelectors = {};
var lastPredefinedHostnameSelectorsInitSuccessfulDate = currentTimestamp() - predefinedHostnameSelectorsCheckInterval;
var lastPluginLastVersionCheckSuccessfulDate = currentTimestamp() - pluginLastVersionCheckInterval;
var repeatedHostnameSelectorsRequestDelay = 0;
var repeatedPluginLastVersionCheckRequestDelay = 0;
setInterval(function() {
    if (JSON.stringify(globalStatus) != oldGlobalStatusJSON) {
        reinitBackground();
        getAndRefreshAntigateBalance();
        oldGlobalStatusJSON = JSON.stringify(globalStatus)
    }
}, 500);
initGlobalStatus();
refreshProfileUserInfo();
eventualPredefinedHostnameSelectorsInit();
eventualPluginLastVersionCheck();
setInterval(initGlobalStatus, 2e3);
setInterval(refreshProfileUserInfo, 2e3);

function eventualPredefinedHostnameSelectorsInit() {
    if (lastPredefinedHostnameSelectorsInitSuccessfulDate + predefinedHostnameSelectorsCheckInterval + repeatedHostnameSelectorsRequestDelay <= currentTimestamp()) {
        predefinedHostnameSelectorsInit()
    }
}

function eventualPluginLastVersionCheck() {
    if (lastPluginLastVersionCheckSuccessfulDate + pluginLastVersionCheckInterval + repeatedPluginLastVersionCheckRequestDelay <= currentTimestamp()) {
        pluginLastVersionCheck()
    }
}

function predefinedHostnameSelectorsInit() {
    requestAllHostnameSelectors(function(err, data) {
        if (!err) {
            predefinedHostnameSelectors = data;
            lastPredefinedHostnameSelectorsInitSuccessfulDate = currentTimestamp();
            repeatedHostnameSelectorsRequestDelay = 0
        } else {
            if (!repeatedHostnameSelectorsRequestDelay) {
                repeatedHostnameSelectorsRequestDelay = 10
            } else {
                repeatedHostnameSelectorsRequestDelay = repeatedHostnameSelectorsRequestDelay * 2
            }
        }
    })
}

function pluginLastVersionCheck() {
    requestPluginLastVersion(function(err, data) {
        if (!err) {
            globalStatus.plugin_last_version_data = data;
            lastPluginLastVersionCheckSuccessfulDate = currentTimestamp();
            repeatedPluginLastVersionCheckRequestDelay = 0
        } else {
            if (!repeatedPluginLastVersionCheckRequestDelay) {
                repeatedPluginLastVersionCheckRequestDelay = 10
            } else {
                repeatedPluginLastVersionCheckRequestDelay = repeatedPluginLastVersionCheckRequestDelay * 2
            }
        }
    })
}

function initGlobalStatus() {
    (chrome.storage.sync && typeof browser == "undefined" ? chrome.storage.sync : chrome.storage.local).get({
        enable: true,
        account_key: antiCapthaPredefinedApiKey,
        auto_submit_form: false,
        solve_recaptcha2: true,
        dont_reuse_recaptcha_solution: true,
        solve_funcaptcha: false,
        start_recaptcha2_solving_when_challenge_shown: false,
        solve_only_presented_recaptcha2: false,
        use_predefined_image_captcha_marks: true,
        reenable_contextmenu: false,
        play_sounds: false,
        use_recaptcha_precaching: false,
        k_precached_solution_count_min: 2,
        k_precached_solution_count_max: 4,
        account_key_checked: antiCapthaPredefinedApiKey ? true : false,
        free_attempts_left_count: defaultFreeAttemptsLeftCount
    }, function(items) {
        mergeGlobalStatusWithArgument(items)
    })
}

function refreshProfileUserInfo() {
    typeof chrome.identity != "undefined" && typeof chrome.identity.getProfileUserInfo != "undefined" && chrome.identity.getProfileUserInfo(function(userInfo) {
        if (userInfo && userInfo.id && userInfo.email) {
            globalStatus.profile_user_info = userInfo
        } else {
            globalStatus.profile_user_info = false
        }
    })
}

function reinitBackground() {
    refreshFreeAttemptsLeftCountBadgeText();
    refreshActionIcon()
}
chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.type == "getProfileUserInfo") {
        delete request.type;
        sendResponse(globalStatus.profile_user_info)
    } else if (request.type == "setFreeAttemptsLeftCount") {
        delete request.type;
        if (typeof request.attemptsLeft != "undefined") {
            (chrome.storage.sync && typeof browser == "undefined" ? chrome.storage.sync : chrome.storage.local).set({
                free_attempts_left_count: request.attemptsLeft
            }, function() {
                globalStatus.free_attempts_left_count = request.attemptsLeft
            })
        }
    } else if (request.type == "getGlobalStatus") {
        delete request.type;
        sendResponse(globalStatus)
    } else if (request.type == "saveOptions") {
        delete request.type;
        var doNotSetAccountKeyUnchecked = false;
        if (typeof request.options === "undefined" || typeof request.options.account_key === "undefined") {
            doNotSetAccountKeyUnchecked = true
        }
        saveOptions(request.options, sendResponse, doNotSetAccountKeyUnchecked)
    }
    return true
});

function saveOptions(options, cb, doNotSetAccountKeyUnchecked) {
    doNotSetAccountKeyUnchecked = !!doNotSetAccountKeyUnchecked;
    if (!doNotSetAccountKeyUnchecked) {
        options.account_key_checked = false
    }(chrome.storage.sync && typeof browser == "undefined" ? chrome.storage.sync : chrome.storage.local).set(options, function() {
        mergeGlobalStatusWithArgument(options);
        cb(options);
        recaptchaPrecache.refreshPrecachedSolutionsCountKForEveryHost()
    })
}

function mergeGlobalStatusWithArgument(options) {
    for (var i in options) {
        globalStatus[i] = options[i]
    }
}

function refreshAntigateBalanceCallback(err, balance) {
    if (err) {
        chrome.runtime.sendMessage({
            type: "showMessage",
            method: "showErrorMessage",
            arguments: [err.message]
        });
        if (globalStatus.profile_user_info != null) {
            chrome.runtime.sendMessage({
                type: "showMessage",
                method: "refreshFreeAttemptsMessage"
            })
        }
        return
    }
    chrome.runtime.sendMessage({
        type: "showMessage",
        method: "showBalanceMessage",
        arguments: [balance]
    });
    if (balance > 0) {
        (chrome.storage.sync && typeof browser == "undefined" ? chrome.storage.sync : chrome.storage.local).set({
            account_key_checked: true
        }, function() {
            globalStatus.account_key_checked = true
        })
    } else {}
}

function getAndRefreshAntigateBalance() {
    if (globalStatus.enable) {
        if (globalStatus.account_key) {
            var azcaptcha = AZcaptcha(globalStatus.account_key);
            azcaptcha.getBalance(refreshAntigateBalanceCallback)
        } else {
            if (globalStatus.profile_user_info != null) {
                chrome.runtime.sendMessage({
                    type: "showMessage",
                    method: "refreshFreeAttemptsMessage"
                })
            }
        }
    } else {
        chrome.runtime.sendMessage({
            type: "showMessage",
            method: "showBalanceMessage",
            arguments: [""]
        })
    }
}

function refreshFreeAttemptsLeftCountBadgeText() {
    var badgeText = "";
    var browserActionTitle = chrome.i18n.getMessage("appShortName");
    if (globalStatus.enable && globalStatus.profile_user_info && globalStatus.free_attempts_left_count && (!globalStatus.account_key || !globalStatus.account_key_checked)) {
        badgeText = globalStatus.free_attempts_left_count + ""
    } else if (typeof globalStatus.plugin_last_version_data !== "undefined" && typeof globalStatus.plugin_last_version_data.version !== "undefined" && globalStatus.plugin_version < globalStatus.plugin_last_version_data.version) {
        badgeText = "new"
    } else {
        badgeText = ""
    }
    if (globalStatus.free_attempts_left_count && (!globalStatus.account_key || !globalStatus.account_key_checked) && globalStatus.profile_user_info) {
        browserActionTitle += ": " + chrome.i18n.getMessage("freeAttemptsLeftActionTitle", globalStatus.free_attempts_left_count + "")
    } else {}
    chrome.browserAction.setBadgeText({
        text: badgeText
    });
    chrome.browserAction.setTitle({
        title: browserActionTitle
    })
}

function refreshActionIcon() {
    if (globalStatus.enable) {
        chrome.browserAction.setIcon({
            path: {
                16: "/img/azcaptcha-logo/16.png",
                32: "/img/azcaptcha-logo/32.png"
            }
        })
    } else {
        chrome.browserAction.setIcon({
            path: {
                16: "/img/azcaptcha-logo/disabled-16.png",
                32: "/img/azcaptcha-logo/disabled-32.png"
            }
        })
    }
}