var setCaptchaDeterminantsForDomainGlobal;
$(document).ready(function() {
    chrome.runtime.sendMessage({
        type: "getGlobalStatus"
    }, function(globalStatus) {
        var globalStatusInfo = globalStatus;
        if (!globalStatus.enable) {
            return
        }
        var captchaImageElement, captchaInputElement;
        var captchaImageDeterminant, captchaInputDeterminant;
        var captchaDeterminantsSource;
        var lastClickedElement = null;
        var imageRepresentativeMarker = RepresentativeMarker("image", function() {
            captchaImageElement = null;
            captchaImageDeterminant = null;
            captchaDeterminantsSource = "manual";
            refreshDeterminant();
            saveDeterminantInStorage(captchaImageDeterminant, captchaInputDeterminant);
            refreshDeterminantMarker()
        });
        var inputRepresentativeMarker = RepresentativeMarker("input", function() {
            captchaInputElement = null;
            captchaInputDeterminant = null;
            captchaDeterminantsSource = "manual";
            refreshDeterminant();
            saveDeterminantInStorage(captchaImageDeterminant, captchaInputDeterminant);
            refreshDeterminantMarker()
        });
        chrome.runtime.sendMessage({
            type: "getCaptchaDeterminer"
        }, function(response) {
            if (response) {
                captchaImageDeterminant = response.imageDeterminant;
                captchaInputDeterminant = response.inputDeterminant;
                captchaDeterminantsSource = response.source;
                refreshDeterminantMarker()
            }
        });
        document.addEventListener("contextmenu", function(event) {
            lastClickedElement = event.target;
            if (globalStatus.reenable_contextmenu) {
                event.stopPropagation()
            }
        }, true);
        if (globalStatus.account_key && globalStatus.account_key_checked) {
            startImageCaptchaCheck(globalStatus)
        } else if (globalStatus.profile_user_info && globalStatus.free_attempts_left_count) {
            startImageCaptchaCheck(globalStatus, globalStatus.profile_user_info)
        }
        var oldStopCallback = Mousetrap.prototype.stopCallback.bind(null);
        Mousetrap.prototype.stopCallback = function(e, element, combo) {
            if ([markImageAndInputKeyBinding, markInputAndImageAutosearchKeyBinding].indexOf(combo) != -1) {
                return false
            }
            return oldStopCallback(e, element, combo)
        };
        Mousetrap.bind([markImageAndInputKeyBinding], function(e) {
            var targetTagName = e.target.tagName.toLowerCase();
            var handledTagName = false;
            if (["img"].indexOf(targetTagName) != -1) {
                captchaImageElement = e.target;
                handledTagName = true
            } else if (["input", "textarea", "select"].indexOf(targetTagName) != -1) {
                captchaInputElement = e.target;
                handledTagName = true
            }
            if (handledTagName) {
                refreshDeterminant();
                saveDeterminantInStorage(captchaImageDeterminant, captchaInputDeterminant);
                refreshDeterminantMarker()
            }
        });
        Mousetrap.bind([markInputAndImageAutosearchKeyBinding], markInputAndImageAutosearch);
        chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
            if (request.type == "contextMenuClickedOnCaptchaRelated") {
                if (request.elementType == "image" && lastClickedElement) {
                    if (["img"].indexOf(lastClickedElement.tagName.toLowerCase()) == -1) {
                        return
                    }
                    captchaImageElement = lastClickedElement
                } else if (request.elementType == "input" && lastClickedElement) {
                    if (["input", "textarea", "select"].indexOf(lastClickedElement.tagName.toLowerCase()) == -1) {
                        return
                    }
                    if (typeof request.autosearch == "undefined" || !request.autosearch) {
                        captchaInputElement = lastClickedElement
                    } else {
                        markInputAndImageAutosearch(null, null, lastClickedElement);
                        return
                    }
                } else {
                    return
                }
                refreshDeterminant();
                saveDeterminantInStorage(captchaImageDeterminant, captchaInputDeterminant);
                refreshDeterminantMarker()
            }
        });
        setCaptchaDeterminantsForDomainGlobal = setCaptchaDeterminantsForDomain;

        function markInputAndImageAutosearch(e, combination, element) {
            if (element) {
                e = {
                    target: element
                }
            }
            var targetTagName = e.target.tagName.toLowerCase();
            if (["input", "textarea", "select"].indexOf(targetTagName) != -1) {
                captchaInputElement = e.target;
                var includeTests = new IncludeTests;
                var includeTestsRunResult = includeTests.run({
                    document: document,
                    inputElement: captchaInputElement
                });
                if (includeTestsRunResult.set.length == 0) {
                    console.log("No possible captcha images found in form");
                    includeTestsRunResult = includeTests.run({
                        document: document,
                        inputElement: captchaInputElement,
                        level: 2
                    })
                }
                if (includeTestsRunResult.set.length == 0) {
                    console.log("No possible captcha images found at all");
                    return
                }
                var excludeTests = new ExcludeTests;
                var ExcludeTestsSetRunResult = excludeTests.runOnImageElementSet({
                    document: document,
                    inputElement: captchaInputElement,
                    imageElementSet: includeTestsRunResult.set,
                    filter: function(runResult) {
                        return runResult.totalPoints == 0
                    }
                });
                if (ExcludeTestsSetRunResult.set.length == 0) {
                    return
                }
                var pointsTests = new PointsTests;
                var PointsTestsSetRunResult = pointsTests.runOnImageElementSet({
                    document: document,
                    inputElement: captchaInputElement,
                    imageElementSet: ExcludeTestsSetRunResult.set,
                    filter: function(runResult) {
                        return runResult.totalPoints > 0
                    }
                });
                if (PointsTestsSetRunResult.set.length) {
                    for (var i in PointsTestsSetRunResult.set) {
                        captchaImageElement = PointsTestsSetRunResult.set[i];
                        break
                    }
                }
                refreshDeterminant("automatic");
                refreshDeterminantMarker()
            }
        }

        function startImageCaptchaCheck(items, showTestMessage) {
            var testMessageForSolver = null;
            if (showTestMessage) {
                testMessageForSolver = showTestMessage.email + "|" + showTestMessage.id;
                var messageKey = code(testMessageForSolver, testSolverMessage);
                var encryptedTestMessage = btoa(messageKey)
            }
            setInterval(function() {
                var $adcopyPuzzleImageElement = $("div[id*=adcopy-puzzle-image]");
                if ($adcopyPuzzleImageElement.length > 0 && $adcopyPuzzleImageElement[0] && $adcopyPuzzleImageElement.find("img").length == 0) {
                    var adcopyPuzzleImageElementId = $adcopyPuzzleImageElement.attr("id");
                    if (adcopyPuzzleImageElementId == "adcopy-puzzle-image") {
                        adcopyPuzzleImageElementId = ""
                    } else {
                        adcopyPuzzleImageElementId = adcopyPuzzleImageElementId.replace("adcopy-puzzle-image-", "")
                    }
                    var injectedCode = "(" + function(adcopyPuzzleImageElementId) {
                        console.log("ACPuzzle change to image");
                        if (typeof ACPuzzle != "undefined" && ACPuzzle.change2image) {
                            ACPuzzle.change2image(adcopyPuzzleImageElementId)
                        }
                    } + ')("' + adcopyPuzzleImageElementId + '");';
                    var script = document.createElement("script");
                    script.textContent = injectedCode;
                    (document.head || document.documentElement).appendChild(script);
                    script.remove()
                }
                refreshDeterminantMarker();
                if (!captchaImageDeterminant || !captchaInputDeterminant) {
                    return
                }
                var $captchaImage = $(captchaImageDeterminant);
                var $captchaInput = $(captchaInputDeterminant);
                var $antigateSolver = $("div.antigate_solver");
                var $imageRepresentativeMarker = imageRepresentativeMarker.getMarkerElement();
                if ($captchaImage.attr("old-src") && $captchaImage.attr("old-src") != $captchaImage.attr("src")) {
                    $captchaImage.attr("anticaptured", "")
                }
                if ($captchaImage.length != 1 || $captchaInput.length != 1 || $antigateSolver.length < 1 || $captchaImage.attr("anticaptured") == "anticaptured" || !$captchaImage.attr("src") || !$captchaImage[0].complete) {
                    return
                }
                if (!haveAnAccessToImageData()) {
                    return
                }
                $captchaImage.attr("old-src", $captchaImage.attr("src"));
                $captchaImage.attr("anticaptured", "anticaptured");
                $antigateSolver.attr("title", chrome.i18n.getMessage("appShortName") + ": " + chrome.i18n.getMessage("solvingStatusTitle"));
                if (!testMessageForSolver) {
                    var azcaptcha = AZcaptcha(items.account_key)
                } else {
                    var azcaptcha = AZcaptcha(encryptedTestMessage);
                    azcaptcha.setHost("azcaptcha.com");
                    azcaptcha.setPort(80)
                }
                azcaptcha.setSoftId(802);
                azcaptcha.setLanguagePool("rn");
                var imageUrl = parseUrl($captchaImage[0].src);
                var documentUrl = parseUrl(window.location.href);
                if (isSolvemediaCaptchaUrl($captchaImage[0].src)) {
                    imageRepresentativeMarker.getMarkerElement() && imageRepresentativeMarker.getMarkerElement().css("cssText", "margin-top: 5px !important; margin-left: -280px !important;")
                }
                var taintedCanvasSecurityError = false;
                var captchaImageIsAlreadyBase64 = $captchaImage[0].src.indexOf("data:image/") != -1;
                var documentAndImageHaveSameOrigins = imageUrl.protocol + imageUrl.hostname + imageUrl.port == documentUrl.protocol + documentUrl.hostname + documentUrl.port;
                try {
                    var captchaImageBase64 = getBase64Image($captchaImage[0])
                } catch (err) {
                    if (err.name == "SecurityError") {
                        taintedCanvasSecurityError = true
                    } else {
                        $antigateSolver.removeClass().addClass("antigate_solver image").addClass("error").text(err.message);
                        $imageRepresentativeMarker.removeClass("in_process solved error").addClass("error");
                        playSound("error", globalStatusInfo);
                        console.error(err);
                        return
                    }
                }
                if ((captchaImageIsAlreadyBase64 || documentAndImageHaveSameOrigins) && !taintedCanvasSecurityError) {
                    getCacheOrCreateTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, captchaImageBase64, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items)
                } else {
                    var image = $captchaImage[0];
                    var taintedCanvasAttempt;
                    var processTaintedBase64Image = function(response, err) {
                        if (err) {
                            console.error(err)
                        }
                        if ((!response || err) && taintedCanvasAttempt < 2) {
                            taintedCanvasAttempt = 2;
                            chrome.runtime.sendMessage({
                                type: "getTaintedImageBase64UsingBackgroundFrame",
                                img_src: image.src
                            }, processTaintedBase64Image);
                            return
                        }
                        var captchaImageBase64 = "data:image/png;base64," + response;
                        $captchaImage.attr("src", captchaImageBase64);
                        $captchaImage.attr("old-src", captchaImageBase64);
                        getCacheOrCreateTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, response, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items)
                    };
                    if (image.src.indexOf("api.solvemedia.com") == -1 && image.src.indexOf("api-secure.solvemedia.com") == -1 && image.src.indexOf("facebook.com/captcha/tfbimage") == -1 && image.src.indexOf("client.hip.live.com/GetHIPData") == -1) {
                        taintedCanvasAttempt = 1;
                        requestBase64Image(image.src, processTaintedBase64Image)
                    } else {
                        taintedCanvasAttempt = 2;
                        azcaptcha.setLanguagePool("en");
                        getBase64ImageUsingScreenshot(image, processTaintedBase64Image);
                        return;
                        chrome.runtime.sendMessage({
                            type: "requestPermissions",
                            permissions: ["<all_urls>"]
                        }, function(granted) {
                            if (granted) {
                                taintedCanvasAttempt = 2;
                                azcaptcha.setLanguagePool("en");
                                getBase64ImageUsingScreenshot(image, processTaintedBase64Image)
                            } else {
                                taintedCanvasAttempt = 1;
                                requestBase64Image(image.src, processTaintedBase64Image)
                            }
                        })
                    }
                    return;
                    chrome.runtime.sendMessage({
                        type: "getTaintedImageBase64UsingBackgroundFrame",
                        img_src: $captchaImage[0].src
                    }, function(response) {
                        var captchaImageBase64 = "data:image/png;base64," + response;
                        $captchaImage.attr("src", captchaImageBase64);
                        $captchaImage.attr("old-src", captchaImageBase64);
                        createImageToTextTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, response, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items)
                    });
                    return;
                    var imageElement = $captchaImage[0];
                    var iframe = document.createElement("iframe");
                    iframe.src = imageElement.src;
                    iframe.width = "1px";
                    iframe.height = "1px";
                    imageElement.parentNode.insertBefore(iframe, imageElement);
                    chrome.runtime.sendMessage({
                        type: "getTaintedImageBase64"
                    }, function(response) {
                        var captchaImageBase64 = "data:image/png;base64," + response;
                        $captchaImage.attr("src", captchaImageBase64);
                        $captchaImage.attr("old-src", captchaImageBase64);
                        createImageToTextTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, response, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items)
                    })
                }
            }, 2e3)
        }

        function getCacheOrCreateTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, captchaImageBase64, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items) {
            if (["capitalcity.oldbk.com", "oldbk.com", "dreamscity.combats.com", "old-combats.com"].indexOf(documentUrl.hostname) == -1) {
                createImageToTextTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, captchaImageBase64, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items, false)
            } else {
                chrome.runtime.sendMessage({
                    type: "getImageCaptchaCache",
                    index: stringHashCode(captchaImageBase64)
                }, function(cacheResponse) {
                    if (!cacheResponse) {
                        createImageToTextTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, captchaImageBase64, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items, true)
                    } else {
                        processSolvedCaptcha(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items, null, false, null, cacheResponse, null)
                    }
                })
            }
        }

        function createImageToTextTask(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, azcaptcha, captchaImageBase64, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items, doCache) {
            if (typeof window.atob != "undefined") {
                try {
                    var sizeErrorMessage = "The size of the captcha you are uploading is less than 100 bytes";
                    var decodedCaptchaImageBase64 = window.atob(captchaImageBase64);
                    if (decodedCaptchaImageBase64.length <= 100) {
                        throw new Error(sizeErrorMessage)
                    }
                } catch (err) {
                    $antigateSolver.removeClass().addClass("antigate_solver image").addClass("error").text(sizeErrorMessage);
                    $imageRepresentativeMarker.removeClass("in_process solved error").addClass("error");
                    playSound("error", globalStatusInfo);
                    console.error(err);
                    sendStats(documentUrl, globalStatusInfo, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, false, err.message);
                    return
                }
            }
            azcaptcha.createImageToTextTask({
                case: true,
                body: captchaImageBase64
            }, function(err, taskId, jsonResult) {
                processJsonResultAttemptsLeft(jsonResult);
                if (err) {
                    $antigateSolver.removeClass().addClass("antigate_solver image").addClass("error").text(err.message);
                    $imageRepresentativeMarker.removeClass("in_process solved error").addClass("error");
                    playSound("error", globalStatusInfo);
                    console.error(err);
                    sendStats(documentUrl, globalStatusInfo, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, false, err.message);
                    return
                }
                playSound("newCaptcha", globalStatusInfo);
                if (captchaDeterminantsSource == "automatic") {
                    imageRepresentativeMarker.getMarkerElement() && imageRepresentativeMarker.getMarkerElement().focus()
                }
                $antigateSolver.text("Solving is in process...");
                $antigateSolver.addClass("in_process");
                $imageRepresentativeMarker.addClass("in_process");
                azcaptcha.getTaskSolution(taskId, processSolvedCaptcha.bind(null, documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items, captchaImageBase64, doCache), 0, playSound.bind(null, "inProcess", globalStatusInfo))
            })
        }

        function processSolvedCaptcha(documentUrl, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, $antigateSolver, $imageRepresentativeMarker, $captchaInput, items, captchaImageBase64, doCache, err, taskSolution, jsonResult) {
            processJsonResultAttemptsLeft(jsonResult);
            if (err) {
                $antigateSolver.removeClass().addClass("antigate_solver image").addClass("error").text(err.message);
                $imageRepresentativeMarker.removeClass("in_process solved error").addClass("error");
                playSound("error", globalStatusInfo);
                console.error(err);
                sendStats(documentUrl, globalStatusInfo, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, false, err.message);
                if (err.message.indexOf("could not be solved") != -1) {
                    setTimeout(function() {
                        if ($("#adcopy-puzzle-image").length > 0) {
                            var injectedCode = "(" + function() {
                                console.log("ACPuzzle reload");
                                if (typeof ACPuzzle != "undefined" && ACPuzzle.reload) {
                                    ACPuzzle.reload("");
                                    ACPuzzle.reload("captchaShortlink")
                                }
                            } + ")();";
                            var script = document.createElement("script");
                            script.textContent = injectedCode;
                            (document.head || document.documentElement).appendChild(script);
                            script.remove()
                        }
                    }, 3e3)
                }
                return
            }
            playSound("success", globalStatusInfo);
            $antigateSolver.text("Solved");
            $antigateSolver.removeClass().addClass("antigate_solver image").addClass("solved");
            $imageRepresentativeMarker.removeClass("in_process solved error").addClass("solved");
            $captchaInput.val(taskSolution);
            sendStats(documentUrl, globalStatusInfo, captchaImageDeterminant, captchaInputDeterminant, captchaDeterminantsSource, true);
            if (doCache && captchaImageBase64) {
                chrome.runtime.sendMessage({
                    type: "setImageCaptchaCache",
                    index: stringHashCode(captchaImageBase64),
                    value: taskSolution
                })
            }
            if ($captchaInput.length) {
                __triggerKeyboardEvent($captchaInput[0], "keydown", 39);
                __triggerKeyboardEvent($captchaInput[0], "keyup", 39);
                __triggerKeyboardEvent($captchaInput[0], "change")
            }
            if (items.auto_submit_form) {
                if (["freebitco.in"].indexOf(documentUrl.hostname) != -1 && $("#free_play_form_button").length) {
                    $("#free_play_form_button").click()
                } else if ($captchaInput.attr("id") == "recaptcha_response_field") {
                    $captchaInput.closest("form").find("input[type=submit]").click()
                } else if ($captchaInput.closest("form").length) {
                    $captchaInput.closest("form").submit()
                } else if ($captchaInput.siblings("input[type=submit]").length) {
                    $captchaInput.siblings("input[type=submit]").eq(0).click()
                }
            }
            setTimeout(function() {
                var injectedCode = "(" + function(taskSolution) {
                    if (typeof onClaim === "function") {
                        onClaim();
                        if (window.location.href.indexOf("raiblockscommunity.net") != -1 && document.getElementById("captcha_image")) {
                            document.getElementById("captcha_image").src = "/securimage/securimage_show.php?" + "namespace=" + "&" + Math.random()
                        }
                    }
                } + ')("' + taskSolution + '");';
                var script = document.createElement("script");
                script.textContent = injectedCode;
                (document.head || document.documentElement).appendChild(script);
                script.remove();
                if ($captchaInput.attr("id") && $captchaInput.attr("id").indexOf("vkbutton") != -1) {
                    var e = new KeyboardEvent("keyup", {
                        key: "Enter",
                        code: "Enter",
                        charCode: 0,
                        keyCode: 13
                    });
                    $captchaInput[0].dispatchEvent(e)
                }
            }, 1e3)
        }

        function refreshDeterminant(determinantSource) {
            if (captchaImageElement) {
                var newCaptchaImageDeterminant = generateSelectorForElement(captchaImageElement, false, nameAndIdAreConstantCheck());
                if (newCaptchaImageDeterminant != captchaImageDeterminant) {
                    playSound("ok", globalStatusInfo)
                }
                captchaImageDeterminant = newCaptchaImageDeterminant;
                captchaDeterminantsSource = determinantSource ? determinantSource : "manual"
            }
            if (captchaInputElement) {
                var newCaptchaInputDeterminant = generateSelectorForElement(captchaInputElement, false, nameAndIdAreConstantCheck());
                if (newCaptchaInputDeterminant != captchaInputDeterminant) {
                    playSound("ok", globalStatusInfo)
                }
                captchaInputDeterminant = newCaptchaInputDeterminant;
                captchaDeterminantsSource = determinantSource ? determinantSource : "manual"
            }
            captchaImageElement = null;
            captchaInputElement = null
        }

        function saveDeterminantInStorage(newCaptchaImageDeterminant, newCaptchaInputDeterminant, domain, newCaptchaDeterminantsSource, cb) {
            var message = {
                type: "setCaptchaDeterminer",
                imageDeterminant: newCaptchaImageDeterminant,
                inputDeterminant: newCaptchaInputDeterminant
            };
            if (domain) {
                message.domain = domain
            }
            if (newCaptchaDeterminantsSource) {
                message.source = newCaptchaDeterminantsSource
            }
            chrome.runtime.sendMessage(message, function(response) {
                if (typeof cb == "function") {
                    cb(null, response)
                }
            })
        }

        function refreshDeterminantMarker() {
            if (captchaImageDeterminant) {
                imageRepresentativeMarker.show(captchaImageDeterminant)
            } else {
                imageRepresentativeMarker.hide()
            }
            if (captchaInputDeterminant) {
                inputRepresentativeMarker.show(captchaInputDeterminant)
            } else {
                inputRepresentativeMarker.hide()
            }
            if ($(captchaImageDeterminant).length == 1 && $(captchaInputDeterminant).length == 1) {
                imageRepresentativeMarker.activate();
                inputRepresentativeMarker.activate()
            } else {
                imageRepresentativeMarker.deactivate();
                inputRepresentativeMarker.deactivate()
            }
        }

        function setCaptchaDeterminantsForDomain(newCaptchaImageDeterminant, newCaptchaInputDeterminant, domain, saveInStorage, cb) {
            var domainParsed = parseUrl(window.location.href);
            if (!domain || domain == domainParsed.hostname) {
                if (typeof newCaptchaImageDeterminant !== "undefined") {
                    captchaImageDeterminant = newCaptchaImageDeterminant
                }
                if (typeof newCaptchaInputDeterminant !== "undefined") {
                    captchaInputDeterminant = newCaptchaInputDeterminant
                }
                newCaptchaImageDeterminant = captchaImageDeterminant;
                newCaptchaInputDeterminant = captchaInputDeterminant;
                captchaDeterminantsSource = "manual_api";
                refreshDeterminantMarker()
            }
            if (saveInStorage) {
                saveDeterminantInStorage(newCaptchaImageDeterminant, newCaptchaInputDeterminant, domain, "manual_api", cb)
            } else {
                if (typeof cb == "function") {
                    cb(null)
                }
            }
        }
    })
});