var processGRecaptchaResponseGlobal;
$(document).ready(function() {
    var globalStatusInfo;
    var encryptedTestMessage = null;
    var recaptchaInfoBySiteKey = [];
    var newRecaptchaRepresentativeAdded = $.Callbacks();
    var allTheRepresentativeConditionsFulfilled = $.Callbacks();
    var recaptchaErrorCallback = $.Callbacks();
    var recaptchaInitCallback = $.Callbacks();
    var recaptchaSolvingInProcessCallback = $.Callbacks();
    var recaptchaSolvedCallback = $.Callbacks();
    var recaptchaExpiredCallback = $.Callbacks();
    var solvedRecaptchaLifetimeCountdown = $.Callbacks();
    var recaptchaRunCallbacksCallback = $.Callbacks();
    var recaptchaCanBeSolvedAfterRepresentativeAddedStatusValues = ["new", "error", "expired"];

    function recaptchaCanBeSolvedAfterRepresentativeAdded(recaptchaInfo) {
        return recaptchaCanBeSolvedAfterRepresentativeAddedStatusValues.indexOf(recaptchaInfo.getStatus()) !== -1
    }

    function recaptchaCanBeRestarted(recaptchaInfo) {
        return ["new", "error", "solved", "expired"].indexOf(recaptchaInfo.getStatus()) !== -1
    }
    newRecaptchaRepresentativeAdded.add(function(recaptchaInfo) {
        if (!recaptchaCanBeSolvedAfterRepresentativeAdded(recaptchaInfo)) {
            return
        }
        recaptchaInfo.setStatus("waiting");
        $.when($.Deferred(function(defer) {
            if (typeof globalStatusInfo.solve_only_presented_recaptcha2 === "undefined" || !globalStatusInfo.solve_only_presented_recaptcha2) {
                defer.resolve()
            } else {
                if (!recaptchaInfo.visibility_check_interval) {
                    recaptchaInfo.visibility_check_interval = setInterval(function() {
                        for (var i in recaptchaInfo.representatives) {
                            if (recaptchaRepresentativeIsNotHidden(recaptchaInfo.representatives[i])) {
                                clearInterval(recaptchaInfo.visibility_check_interval);
                                defer.resolve();
                                return
                            } else {}
                        }
                    }, 200)
                } else {}
            }
        }), $.Deferred(function(defer) {
            if (typeof globalStatusInfo.start_recaptcha2_solving_when_challenge_shown === "undefined" || !globalStatusInfo.start_recaptcha2_solving_when_challenge_shown) {
                defer.resolve()
            } else {
                if (!recaptchaInfo.challenge_shown_check_interval) {
                    recaptchaInfo.challenge_shown_check_interval = setInterval(function() {
                        var allIframes = document.getElementsByTagName("iframe");
                        for (i = 0; i < allIframes.length; i++) {
                            if (allIframes[i].src.indexOf("www.google.com/recaptcha/api2/bframe") != -1 && allIframes[i].src.indexOf(recaptchaInfo.siteKey) != -1) {
                                if (!$(allIframes[i]).is(":hidden") && !$(allIframes[i]).parents().filter(function() {
                                        return this.style.visibility == "hidden"
                                    }).length) {
                                    clearInterval(recaptchaInfo.challenge_shown_check_interval);
                                    recaptchaInfo.challenge_shown_iframe_determinant = allIframes[i].src;
                                    recaptchaInfo.challenge_shown_iframe_name = allIframes[i].name;
                                    defer.resolve();
                                    break
                                }
                            }
                        }
                    }, 200)
                } else {}
            }
        })).done(function() {
            allTheRepresentativeConditionsFulfilled.fire(recaptchaInfo)
        })
    });
    allTheRepresentativeConditionsFulfilled.add(function(recaptchaInfo) {
        createTaskProxyless(recaptchaInfo)
    });
    recaptchaErrorCallback.add(function(err, recaptchaInfo) {
        recaptchaInfo.setStatus("error")
    });
    recaptchaErrorCallback.add(function(err, recaptchaInfo) {
        recaptchaInfo.html_elements.$antigate_solver.removeClass().addClass("antigate_solver recaptcha").addClass("error");
        recaptchaInfo.html_elements.$antigate_solver_status.text(err.message);
        console.error(err);
        if (typeof err.message != "undefined" && (err.message.toLowerCase().indexOf("task you are requesting does not exist") !== -1 || err.message.toLowerCase().indexOf("no idle workers") !== -1)) {
            recaptchaInfo.html_elements.$antigate_solver_status.append("<br /> One more attempt in 2 seconds");
            playSound("minorError", globalStatusInfo);
            setTimeout(function() {
                restartTaskProxyless(recaptchaInfo)
            }, 2e3)
        } else {
            playSound("error", globalStatusInfo)
        }
    });
    recaptchaInitCallback.add(function(recaptchaInfo) {
        recaptchaInfo.html_elements.$antigate_solver_control.attr("title", "").text("").removeClass().addClass("control");
        recaptchaInfo.html_elements.$antigate_solver.removeClass().addClass("antigate_solver recaptcha");
        recaptchaInfo.html_elements.$antigate_solver_status.text("AZcaptcha");
        recaptchaInfo.html_elements.$grecaptcha_anchor_frame_container.find(".solved_flag").remove()
    });
    recaptchaSolvingInProcessCallback.add(function(recaptchaInfo) {
        recaptchaInfo.setStatus("solving")
    });
    recaptchaSolvingInProcessCallback.add(function(recaptchaInfo) {
        recaptchaInfo.html_elements.$antigate_solver_status.text("Solving is in process...");
        recaptchaInfo.html_elements.$antigate_solver.addClass("in_process");
        playSound("newCaptcha", globalStatusInfo)
    });
    recaptchaSolvedCallback.add(function(recaptchaInfo) {
        recaptchaInfo.setStatus("solved")
    });
    recaptchaSolvedCallback.add(function(recaptchaInfo, taskSolution) {
        recaptchaInfo.html_elements.$antigate_solver_status.text("Solved");
        recaptchaInfo.html_elements.$antigate_solver.removeClass().addClass("antigate_solver recaptcha").addClass("solved");
        playSound("success", globalStatusInfo);
        recaptchaInfo.html_elements.$grecaptcha_anchor_frame_container.append('<img src="' + chrome.extension.getURL("img/flag_blue.png") + '" alt="Recaptcha solved" class="solved_flag" />');
        recaptchaInfo.html_elements.$grecaptcha_response.val(taskSolution);
        for (var i in recaptchaInfo.representatives) {
            recaptchaInfo.representatives[i].is_visible_on_finish = recaptchaRepresentativeIsNotHidden(recaptchaInfo.representatives[i])
        }
    });
    recaptchaExpiredCallback.add(function(recaptchaInfo) {
        recaptchaInfo.setStatus("expired")
    });
    recaptchaExpiredCallback.add(function(recaptchaInfo) {
        recaptchaInfo.html_elements.$antigate_solver_control.text("");
        recaptchaInfo.html_elements.$antigate_solver_control.attr("title", chrome.i18n.getMessage("appShortName") + ": " + chrome.i18n.getMessage("outdatedRecaptchaTitle") + " " + chrome.i18n.getMessage("refreshRecaptchaTitle"));
        recaptchaInfo.html_elements.$antigate_solver_control.removeClass().addClass("control").addClass("reload");
        recaptchaInfo.html_elements.$antigate_solver.removeClass().addClass("antigate_solver recaptcha").addClass("error");
        recaptchaInfo.html_elements.$antigate_solver_status.text("Outdated, should be solved again");
        playSound("minorError", globalStatusInfo);
        recaptchaInfo.html_elements.$grecaptcha_anchor_frame_container.find(".solved_flag").remove();
        recaptchaInfo.html_elements.$grecaptcha_response.val("")
    });
    recaptchaRunCallbacksCallback.add(function(recaptchaInfo, taskSolution) {
        var parameters = {
            siteKey: recaptchaInfo.siteKey,
            task_solution: taskSolution,
            challenge_shown_iframe_determinant: recaptchaInfo.challenge_shown_iframe_determinant,
            challenge_shown_iframe_name: recaptchaInfo.challenge_shown_iframe_name,
            requested_from_api_representative_determinant: recaptchaInfo.requested_from_api_representative_determinant
        };
        var injectedCode = "(" + function(taskSolution) {
            var recaptchaCallbackAlreadyFired = false;
            var parameters = {};
            if (document.currentScript && document.currentScript.dataset && document.currentScript.dataset["parameters"]) {
                try {
                    parameters = JSON.parse(document.currentScript.dataset["parameters"])
                } catch (e) {}
            }
            if (parameters.requested_from_api_representative_determinant) {
                recaptchaCallbackAlreadyFired = recaptchaApiRequestedRepresentativeBasedCallback(parameters);
                if (recaptchaCallbackAlreadyFired !== false) {
                    return
                }
            }
            if (!recaptchaCallbackAlreadyFired) {
                recaptchaCallbackAlreadyFired = oneVisibleRecaptchaBasedCallback(parameters);
                if (recaptchaCallbackAlreadyFired !== false) {
                    return
                }
            }
            if (parameters.challenge_shown_iframe_name || parameters.challenge_shown_iframe_determinant) {
                recaptchaCallbackAlreadyFired = challengeShownBasedCallback(parameters);
                if (recaptchaCallbackAlreadyFired !== false) {
                    return
                }
            }

            function recaptchaApiRequestedRepresentativeBasedCallback(parameters) {
                var recaptchaApiRequestedRepresentativeElement = null;
                try {
                    recaptchaApiRequestedRepresentativeElement = document.querySelector(parameters.requested_from_api_representative_determinant)
                } catch (e) {}
                if (recaptchaApiRequestedRepresentativeElement) {
                    var apiRequestedRepresentativeClientSearchResult = findObjectInGrecaptchaCfgByTestFunctionRecursive(___grecaptcha_cfg.clients, function(recaptchaRepresentativeElement, object) {
                        return object && typeof object.nodeName == "string" && object.nodeName.toLowerCase() == "div" && recaptchaRepresentativeElement == object
                    }.bind(null, recaptchaApiRequestedRepresentativeElement), 3);
                    if (apiRequestedRepresentativeClientSearchResult && apiRequestedRepresentativeClientSearchResult.element && apiRequestedRepresentativeClientSearchResult.keys.length && typeof apiRequestedRepresentativeClientSearchResult.keys[0] !== "undefined" && typeof ___grecaptcha_cfg.clients[apiRequestedRepresentativeClientSearchResult.keys[0]] !== "undefined") {
                        recursiveCallbackOneTimeRun(___grecaptcha_cfg.clients[apiRequestedRepresentativeClientSearchResult.keys[0]], taskSolution, 1, 2);
                        return apiRequestedRepresentativeClientSearchResult.keys[0]
                    } else {
                        return false
                    }
                } else {
                    return false
                }
            }

            function challengeShownBasedCallback(parameters) {
                var challengeClientSearchResult = findObjectInGrecaptchaCfgByTestFunctionRecursive(___grecaptcha_cfg.clients, function(iframeName, iframeDeterminant, object) {
                    return object && typeof object.nodeName == "string" && object.nodeName.toLowerCase() == "iframe" && (iframeName && typeof object.name == "string" && object.name == iframeName || iframeDeterminant && typeof object.src == "string" && object.src == iframeDeterminant)
                }.bind(null, parameters.challenge_shown_iframe_name, parameters.challenge_shown_iframe_determinant), 3);
                if (challengeClientSearchResult && challengeClientSearchResult.element && challengeClientSearchResult.keys.length && typeof challengeClientSearchResult.keys[0] !== "undefined" && typeof ___grecaptcha_cfg.clients[challengeClientSearchResult.keys[0]] !== "undefined") {
                    recursiveCallbackOneTimeRun(___grecaptcha_cfg.clients[challengeClientSearchResult.keys[0]], taskSolution, 1, 2);
                    return challengeClientSearchResult.keys[0]
                } else {
                    return false
                }
            }

            function oneVisibleRecaptchaBasedCallback(parameters) {
                var visibleRecaptchaClients = [];
                for (var i in ___grecaptcha_cfg.clients) {
                    var callback = function(siteKey, object) {
                        return object && typeof object.nodeName == "string" && typeof object.innerHTML == "string" && object.innerHTML.indexOf("iframe") !== -1 && object.innerHTML.indexOf("recaptcha/api2/anchor") !== -1 && object.innerHTML.indexOf(siteKey) !== -1 && (object.offsetHeight != 0 || object.childNodes.length && object.childNodes[0].offsetHeight != 0)
                    };
                    var generatedCallback;
                    if (typeof Function.prototype.bind !== "undefined" && Function.prototype.bind.toString().indexOf("this.create") == -1) {
                        generatedCallback = callback.bind(null, parameters.siteKey)
                    } else {
                        generatedCallback = function() {
                            return callback.apply(null, [parameters.siteKey].concat(Array.from(arguments)))
                        }
                    }
                    var visibleRecaptchaClient = findObjectInGrecaptchaCfgByTestFunctionRecursive(___grecaptcha_cfg.clients[i], generatedCallback, 1);
                    if (visibleRecaptchaClient.element) {
                        visibleRecaptchaClient.keys.unshift(i);
                        visibleRecaptchaClients.push(visibleRecaptchaClient)
                    }
                }
                if (visibleRecaptchaClients.length === 1 && visibleRecaptchaClients[0].element && visibleRecaptchaClients[0].keys.length && typeof visibleRecaptchaClients[0].keys[0] !== "undefined" && typeof ___grecaptcha_cfg.clients[visibleRecaptchaClients[0].keys[0]] !== "undefined") {
                    recursiveCallbackOneTimeRun(___grecaptcha_cfg.clients[visibleRecaptchaClients[0].keys[0]], taskSolution, 1, 2);
                    return visibleRecaptchaClients[0].keys[0]
                }
                return false
            }

            function findObjectInGrecaptchaCfgByTestFunctionRecursive(object, testFunction, maxDepth, currentDepth) {
                var result = {
                    element: null,
                    keys: []
                };
                if (typeof currentDepth == "undefined") {
                    currentDepth = 1
                }
                if (typeof maxDepth == "undefined") {
                    maxDepth = 1
                }
                if (currentDepth > maxDepth) {
                    return result
                }
                for (var i in object) {
                    try {
                        if (testFunction(object[i])) {
                            result.element = object[i];
                            result.keys.push(i);
                            break
                        } else if (currentDepth < maxDepth) {
                            result = findObjectInGrecaptchaCfgByTestFunctionRecursive(object[i], testFunction, maxDepth, currentDepth + 1);
                            if (result.element) {
                                result.keys.unshift(i);
                                break
                            }
                        }
                    } catch (e) {}
                }
                return result
            }

            function recursiveCallbackOneTimeRun(object, solution, currentDepth, maxDepth) {
                var passedProperties = 0;
                for (var i in object) {
                    passedProperties++;
                    if (passedProperties > 15) {
                        break
                    }
                    try {
                        if (typeof object[i] == "object" && currentDepth <= maxDepth) {
                            if (recursiveCallbackOneTimeRun(object[i], solution, currentDepth + 1, maxDepth)) {
                                return true
                            }
                        } else if (i == "callback") {
                            if (typeof object[i] == "function") {
                                object[i](solution);
                                return true
                            } else if (typeof object[i] == "string" && typeof window[object[i]] == "function") {
                                window[object[i]](solution);
                                return true
                            }
                        }
                    } catch (e) {}
                }
                return false
            }
        } + ')("' + taskSolution + '");';
        var script = document.createElement("script");
        script.dataset["parameters"] = JSON.stringify(parameters);
        script.textContent = injectedCode;
        (document.head || document.documentElement).appendChild(script);
        if (globalStatusInfo.auto_submit_form) {
            if (recaptchaInfo.html_elements.$grecaptcha_container.first().closest("form").find("input[type=submit]").length == 1) {
                recaptchaInfo.html_elements.$grecaptcha_container.first().closest("form").find("input[type=submit]").click()
            } else if (recaptchaInfo.html_elements.$grecaptcha_container.first().closest("form").length) {
                recaptchaInfo.html_elements.$grecaptcha_container.first().closest("form").submit()
            } else if (recaptchaInfo.html_elements.$grecaptcha_container.first().parent().siblings("input[type=submit]").length) {
                recaptchaInfo.html_elements.$grecaptcha_container.first().parent().siblings("input[type=submit]").eq(0).click()
            }
        }
    });
    chrome.runtime.sendMessage({
        type: "getGlobalStatus"
    }, function(globalStatus) {
        globalStatusInfo = globalStatus;
        if (globalStatus.enable) {
            if (globalStatus.solve_recaptcha2) {
                if (globalStatus.account_key && globalStatus.account_key_checked) {
                    startRecaptchaCollecting()
                } else if (globalStatus.profile_user_info && globalStatus.free_attempts_left_count) {
                    startRecaptchaCollecting(globalStatus.profile_user_info)
                }
            }
            if (globalStatus.dont_reuse_recaptcha_solution) {
                recaptchaCanBeSolvedAfterRepresentativeAddedStatusValues.push("solved")
            }
        }
    });
    processGRecaptchaResponseGlobal = processGRecaptchaResponse;

    function restartTaskProxyless(recaptchaInfo) {
        if (recaptchaCanBeRestarted(recaptchaInfo)) {
            createTaskProxyless(recaptchaInfo)
        }
    }

    function createTaskProxyless(recaptchaInfo) {
        recaptchaInitCallback.fire(recaptchaInfo);
        for (var i in recaptchaInfo.representatives) {
            recaptchaInfo.representatives[i].is_visible_on_start = recaptchaRepresentativeIsNotHidden(recaptchaInfo.representatives[i])
        }
        if (recaptchaInfo.freshness_lifetime_timeout) {
            clearTimeout(recaptchaInfo.freshness_lifetime_timeout)
        }
        if (recaptchaInfo.freshness_countdown_interval) {
            clearInterval(recaptchaInfo.freshness_countdown_interval)
        }
        recaptchaInfo.azcaptcha.createTaskProxyless(function(err, taskId, jsonResult) {
            processJsonResultAttemptsLeft(jsonResult);
            if (err) {
                recaptchaErrorCallback.fire(err, recaptchaInfo);
                return
            }
            recaptchaSolvingInProcessCallback.fire(recaptchaInfo);
            recaptchaInfo.azcaptcha.getTaskSolution(taskId, function(err, taskSolution, jsonResult) {
                processJsonResultAttemptsLeft(jsonResult);
                if (err) {
                    recaptchaErrorCallback.fire(err, recaptchaInfo);
                    return
                }
                recaptchaSolvedCallback.fire(recaptchaInfo, taskSolution);
                recaptchaRunCallbacksCallback.fire(recaptchaInfo, taskSolution);
                solvedRecaptchaLifetimeCountdown.fire(recaptchaInfo, jsonResult)
            }, 0, playSound.bind(null, "inProcess", globalStatusInfo))
        })
    }
    solvedRecaptchaLifetimeCountdown.add(function(recaptchaInfo, jsonResult) {
        var solutionLifetime = 110;
        if (typeof jsonResult.lifetime !== "undefined") {
            solutionLifetime = jsonResult.lifetime
        }
        var countdownTime = 30;
        var beforeCountdownTime = solutionLifetime - 30;
        if (beforeCountdownTime < 0) {
            countdownTime = countdownTime + beforeCountdownTime;
            beforeCountdownTime = 0
        }
        recaptchaInfo.freshness_lifetime_timeout = setTimeout(function() {
            recaptchaInfo.html_elements.$antigate_solver.addClass("pulsate");
            recaptchaInfo.html_elements.$antigate_solver_control.attr("tabindex", 0);
            recaptchaInfo.html_elements.$antigate_solver_control.addClass("reload active");
            var startTime = countdownTime;
            recaptchaInfo.html_elements.$antigate_solver_control.text(startTime);
            recaptchaInfo.html_elements.$antigate_solver_control.attr("title", chrome.i18n.getMessage("appShortName") + ": " + chrome.i18n.getMessage("agingRecaptchaTitle").replace("%s", startTime) + " " + chrome.i18n.getMessage("refreshRecaptchaTitle"));
            recaptchaInfo.freshness_countdown_interval = setInterval(function() {
                startTime--;
                recaptchaInfo.html_elements.$antigate_solver_control.text(startTime);
                recaptchaInfo.html_elements.$antigate_solver_control.attr("title", chrome.i18n.getMessage("appShortName") + ": " + chrome.i18n.getMessage("agingRecaptchaTitle").replace("%s", startTime) + " " + chrome.i18n.getMessage("refreshRecaptchaTitle"));
                if (startTime <= 0) {
                    clearInterval(recaptchaInfo.freshness_countdown_interval);
                    recaptchaExpiredCallback.fire(recaptchaInfo)
                }
            }, 1e3);
            var actionReaction = function(event, usingKeyboard) {
                if (recaptchaInfo.freshness_countdown_interval) {
                    clearInterval(recaptchaInfo.freshness_countdown_interval)
                }
                recaptchaInfo.html_elements.$grecaptcha_response.val("");
                recaptchaInfo.html_elements.$antigate_solver_control.off("click keypress");
                recaptchaInfo.html_elements.$antigate_solver_control.removeAttr("tabindex");
                if (usingKeyboard) {
                    recaptchaInfo.html_elements.$antigate_solver_status.focus()
                }
                restartTaskProxyless(recaptchaInfo)
            };
            recaptchaInfo.html_elements.$antigate_solver_control.on("click", actionReaction);
            recaptchaInfo.html_elements.$antigate_solver_control.on("keypress", function(e) {
                if (e.which == 32 || e.which == 13) {
                    actionReaction(e, true)
                }
            })
        }, beforeCountdownTime * 1e3)
    });

    function initEncryptedTestMessageOnce(showTestMessage) {
        if (showTestMessage && !encryptedTestMessage) {
            var testMessageForSolver = showTestMessage.email + "|" + showTestMessage.id;
            var messageKey = code(testMessageForSolver, testSolverMessage);
            encryptedTestMessage = btoa(messageKey)
        }
    }

    function startRecaptchaCollecting(showTestMessage) {
        setInterval(function() {
            $(".g-recaptcha-response:not([anticaptured])").each(function() {
                processGRecaptchaResponse.call(this, showTestMessage)
            })
        }, 1e3)
    }

    function recaptchaRepresentativeIsNotHidden(recaptchaRepresentative) {
        return recaptchaRepresentative.$representative_html_element[0].offsetHeight != 0 || $(recaptchaRepresentative.response_html_element).parent()[0].offsetHeight != 0
    }

    function processGRecaptchaResponse(showTestMessage, requestedFromAPI) {
        initEncryptedTestMessageOnce(showTestMessage);
        requestedFromAPI = !!requestedFromAPI;
        var gRecaptchaResponse = this;
        var $gRecaptchaResponse = $(gRecaptchaResponse);
        var $recaptchaAnchorIframe = $gRecaptchaResponse.parent().find("iframe");
        if (!$recaptchaAnchorIframe.length || !$recaptchaAnchorIframe.attr("src")) {
            return
        }
        var anchorIframeUrl = parseUrl($recaptchaAnchorIframe.attr("src"));
        var siteKey = getIframeSiteKey(anchorIframeUrl.search);
        if (!siteKey || anchorIframeUrl.search == siteKey) {
            return
        }
        siteKey = $.trim(decodeURIComponent(siteKey));
        var stoken = null;
        if (anchorIframeUrl.search.indexOf("stoken=") != -1) {
            stoken = anchorIframeUrl.search.replace(/.*stoken=([^&]+)&?.*/, "$1")
        }
        if (typeof recaptchaInfoBySiteKey[siteKey] === "undefined") {
            recaptchaInfoBySiteKey[siteKey] = {
                azcaptcha: null,
                siteKey: siteKey,
                stoken: stoken,
                representatives: [],
                html_elements: {
                    $antigate_solver: $(),
                    $antigate_solver_status: $(),
                    $antigate_solver_control: $(),
                    $grecaptcha_response: $(),
                    $grecaptcha_anchor_frame_container: $(),
                    $grecaptcha_anchor_frame: $(),
                    $grecaptcha_container: $()
                },
                status: null,
                getStatus: function() {
                    return this.status
                },
                setStatus: function(status) {
                    return this.status = status
                },
                freshness_lifetime_timeout: null,
                freshness_countdown_interval: null,
                visibility_check_interval: null,
                challenge_shown_check_interval: null,
                challenge_shown_iframe_determinant: null,
                challenge_shown_iframe_name: null,
                requested_from_api: null,
                requested_from_api_representative_determinant: null
            };
            recaptchaInfoBySiteKey[siteKey].setStatus("new")
        }
        var $gRecaptchaRepresentative = findRecaptchaRepresentative($gRecaptchaResponse);
        if (requestedFromAPI && !recaptchaInfoBySiteKey[siteKey].requested_from_api_representative_determinant) {
            recaptchaInfoBySiteKey[siteKey].requested_from_api_representative_determinant = $.trim(generateSelectorForElement($gRecaptchaRepresentative.get(0)));
            recaptchaInfoBySiteKey[siteKey].requested_from_api = true
        }
        var recaptchaRepresentative = {
            response_html_element: gRecaptchaResponse,
            $representative_html_element: $gRecaptchaRepresentative,
            is_invisible_recaptcha: $gRecaptchaRepresentative.find(".grecaptcha-badge").length,
            use_current_callback: false,
            requested_from_api: requestedFromAPI,
            is_visible_on_detection: null,
            is_visible_on_start: null,
            is_visible_on_finish: null
        };
        recaptchaRepresentative.is_visible_on_detection = recaptchaRepresentativeIsNotHidden(recaptchaRepresentative);
        recaptchaInfoBySiteKey[siteKey].representatives.push(recaptchaRepresentative);
        var $gRecaptchaFrameContainer = $gRecaptchaResponse.prev("div");
        if (recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame_container.length && recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame_container.find(".solved_flag").length) {
            $gRecaptchaFrameContainer.append(recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame_container.find(".solved_flag").clone())
        }
        var $gRecaptchaContainer = $gRecaptchaResponse.parent();
        $gRecaptchaContainer.height("auto");
        if (!recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver.length) {
            $gRecaptchaContainer.append('<div class="antigate_solver recaptcha"><a class="status">AZcaptcha</a><a class="control"></a></div>')
        } else {
            $gRecaptchaContainer.append(recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver.first().clone(true))
        }
        var $antigateSolver = $gRecaptchaContainer.find(".antigate_solver.recaptcha");
        if ($antigateSolver.parent(".grecaptcha-badge").length) {
            $antigateSolver.css("cssText", "width: 256px !important;")
        }
        if (recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_response.length) {
            $gRecaptchaResponse.val(recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_response.val())
        }
        recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver = recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver.add($antigateSolver);
        recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver_status = recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver_status.add($gRecaptchaContainer.find(".antigate_solver.recaptcha a.status"));
        recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver_control = recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver_control.add($gRecaptchaContainer.find(".antigate_solver.recaptcha a.control"));
        recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_response = recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_response.add($gRecaptchaResponse);
        recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame_container = recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame_container.add($gRecaptchaFrameContainer);
        recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame = recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_anchor_frame.add($recaptchaAnchorIframe);
        recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_container = recaptchaInfoBySiteKey[siteKey].html_elements.$grecaptcha_container.add($gRecaptchaContainer);
        recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver_status.attr("tabindex", 0);
        recaptchaInfoBySiteKey[siteKey].html_elements.$antigate_solver_status.attr("title", chrome.i18n.getMessage("appShortName") + ": " + chrome.i18n.getMessage("solvingStatusTitle"));
        $gRecaptchaResponse.attr("anticaptured", "anticaptured");
        if (recaptchaInfoBySiteKey[siteKey].azcaptcha === null) {
            if (!showTestMessage || !encryptedTestMessage) {
                var azcaptcha = AZcaptcha(globalStatusInfo.account_key, globalStatusInfo.use_recaptcha_precaching)
            } else {
                var azcaptcha = AZcaptcha(encryptedTestMessage);
                azcaptcha.setHost("azcaptcha.com");
                azcaptcha.setPort(8083)
            }
            azcaptcha.setWebsiteURL(getBaseUrl(window.location.href));
            azcaptcha.setWebsiteKey(siteKey);
            if (stoken) {
                azcaptcha.setWebsiteSToken(stoken)
            }
            azcaptcha.setSoftId(802);
            recaptchaInfoBySiteKey[siteKey].azcaptcha = azcaptcha
        }
        newRecaptchaRepresentativeAdded.fire(recaptchaInfoBySiteKey[siteKey])
    }

    function findRecaptchaRepresentative($gRecaptchaResponse) {
        return $gRecaptchaResponse.parent().parent()
    }

    function recursiveCallbackFunctionSearch(object, currentDepth, maxDepth) {
        var passedProperties = 0;
        for (var i in object) {
            passedProperties++;
            if (passedProperties > 15) {
                break
            }
            try {
                if (typeof object[i] == "object" && currentDepth <= maxDepth) {
                    return recursiveCallbackFunctionSearch(object[i], currentDepth + 1, maxDepth)
                } else if (i == "callback") {
                    if (typeof object[i] == "function") {
                        return object[i]
                    } else if (typeof object[i] == "string" && typeof window[object[i]] == "function") {
                        return window[object[i]]
                    }
                    return
                }
            } catch (e) {}
        }
    }
});

function processGRecaptchaElement(gRecaptchaElementSelector) {
    var showTestMessage = null;
    if (typeof globalStatusInfo !== "undefined" && (!globalStatusInfo.account_key || !globalStatusInfo.account_key_checked) && globalStatusInfo.profile_user_info && globalStatusInfo.free_attempts_left_count) {
        showTestMessage = globalStatusInfo.profile_user_info
    }
    $(gRecaptchaElementSelector).find(".g-recaptcha-response:not([anticaptured])").each(function() {
        processGRecaptchaResponseGlobal.call(this, showTestMessage, true)
    })
}