chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.type == "notifyRecaptchaPrecacheDebugPage") {
        var dataType = request.dataType;
        var postData = request.postData;
        console.log("dataType = ", dataType);
        console.log("postData = ", postData);
        data = postData;
        var divContainer = document.getElementById("allTheData");
        divContainer.innerHTML = "";
        if (dataType == "precachedSolutions") {
            divContainer.appendChild(visualizePrecachedSolutionsData(postData))
        }
    }
});
var cacheFreshnessTime = 110;

function visualizeTasksData(tasksData) {
    var tasksTable = document.createElement("table");
    tasksTable.border = 1;
    tasksTable.createCaption().innerHTML = "Tasks";
    var trTasksHead = tasksTable.insertRow();
    for (var taskIndex in tasksData) {
        var trTasksData = tasksTable.insertRow();
        for (var taskDataKey in tasksData[taskIndex]) {
            if (taskIndex == 0) {
                var th = document.createElement("th");
                th.innerHTML = taskDataKey;
                trTasksHead.appendChild(th);
                if (taskDataKey == "endTime") {
                    var th = document.createElement("th");
                    th.innerHTML = "solvingTime";
                    th.style.color = "gray";
                    trTasksHead.appendChild(th);
                    var th = document.createElement("th");
                    th.innerHTML = "feelsLikeSolvingTime";
                    th.style.color = "gray";
                    trTasksHead.appendChild(th);
                    var th = document.createElement("th");
                    th.innerHTML = "expirationCountdown";
                    th.style.color = "gray";
                    trTasksHead.appendChild(th)
                } else if (1) {}
            }
            if (taskDataKey == "taskData") {
                trTasksData.insertCell().innerHTML = "<b>hostname:</b> " + tasksData[taskIndex][taskDataKey].hostname + ";<br /> <b>sitekey:</b> " + tasksData[taskIndex][taskDataKey].siteKey
            } else if (taskDataKey == "solution") {
                trTasksData.insertCell().innerHTML = typeof tasksData[taskIndex][taskDataKey] == "string" ? tasksData[taskIndex][taskDataKey].substring(0, 50) + "..." : tasksData[taskIndex][taskDataKey]
            } else if (taskDataKey == "expired") {
                trTasksData.insertCell().innerHTML = '<span style="color: ' + (tasksData[taskIndex][taskDataKey] ? "Crimson" : "ForestGreen") + ';">' + tasksData[taskIndex][taskDataKey] + "</span>"
            } else if (taskDataKey == "taskProcessingToContentScriptTime") {
                trTasksData.insertCell().innerHTML = '<span style="color: ' + (tasksData[taskIndex][taskDataKey] ? "ForestGreen" : "Crimson") + ';">' + tasksData[taskIndex][taskDataKey] + "</span>"
            } else if (taskDataKey == "error") {
                trTasksData.insertCell().innerHTML = tasksData[taskIndex][taskDataKey] ? '<span style="color: Crimson;">' + tasksData[taskIndex][taskDataKey] + "</span>" : ""
            } else if (taskDataKey == "endTime") {
                trTasksData.insertCell().innerHTML = tasksData[taskIndex][taskDataKey];
                trTasksData.insertCell().innerHTML = (tasksData[taskIndex][taskDataKey] ? tasksData[taskIndex][taskDataKey] : currentTimestamp()) - tasksData[taskIndex]["startTime"];
                trTasksData.insertCell().innerHTML = tasksData[taskIndex]["taskProcessingToContentScriptTime"] ? tasksData[taskIndex]["taskProcessingToContentScriptTime"] - tasksData[taskIndex]["requestTime"] : "";
                var expirationCountdown = tasksData[taskIndex][taskDataKey] ? cacheFreshnessTime - (currentTimestamp() - tasksData[taskIndex][taskDataKey]) : 0;
                trTasksData.insertCell().innerHTML = expirationCountdown ? '<span style="color: ' + (expirationCountdown > 0 ? "ForestGreen" : "Crimson") + ';">' + expirationCountdown + "</span>" : ""
            } else {
                trTasksData.insertCell().innerHTML = tasksData[taskIndex][taskDataKey]
            }
        }
    }
    return tasksTable
}

function visualizePrecachedSolutionsData(precachedSolutions, k) {
    var container = document.createElement("div");
    for (var hostname in precachedSolutions) {
        var table = document.createElement("table");
        table.border = 1;
        table.createCaption().innerHTML = hostname;
        container.appendChild(table);
        var trHead = table.insertRow();
        var trData = table.insertRow();
        for (var hostnameDataKey in precachedSolutions[hostname]) {
            if (hostnameDataKey == "tasks") {
                container.appendChild(visualizeTasksData(precachedSolutions[hostname][hostnameDataKey]))
            } else {
                var tabCell = trData.insertCell();
                var th = document.createElement("th");
                th.innerHTML = hostnameDataKey;
                trHead.appendChild(th);
                if (hostnameDataKey == "noCacheRequestsSinceLastSolutionExpiration") {
                    tabCell.innerHTML = '<span style="color: ' + (precachedSolutions[hostname][hostnameDataKey] ? "Crimson" : "ForestGreen") + ';">' + precachedSolutions[hostname][hostnameDataKey] + "</span>"
                } else {
                    tabCell.innerHTML = precachedSolutions[hostname][hostnameDataKey]
                }
            }
        }
    }
    return container
}
var data;

function CreateTableFromJSON(data, k) {
    console.log("CreateTableFromJSON");
    console.log("data = ", data);
    console.log("k = ", k);
    if (k > 0) {
        console.log("ZAEBAL!!!");
        return document.createTextNode("zaebal!")
    }
    var col = [];
    for (var i in data) {
        for (var key in data[i]) {
            if (col.indexOf(key) === -1) {
                col.push(key)
            }
        }
    }
    var table = document.createElement("table");
    table.border = 1;
    var tr = table.insertRow(-1);
    for (var i = 0; i < col.length; i++) {
        var th = document.createElement("th");
        th.innerHTML = col[i];
        tr.appendChild(th)
    }
    tr = table.insertRow(-1);
    for (var i in data) {
        var tabCell = tr.insertCell(-1);
        console.log("data[i][col[j]] = ", data[i]);
        console.log("typeof data[i][col[j]] = ", typeof data[i]);
        if (typeof data[i] === "object" && data[i]) {
            tabCell.appendChild(CreateTableFromJSON(data[i], k + 1))
        } else {
            tabCell.innerHTML = data[i]
        }
    }
    return table
}

function currentTimestamp() {
    return Math.floor(Date.now() / 1e3)
}