(function() {
    var taintedImageBase64Callback = [];
    chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
        if (request.type == "getTaintedImageBase64") {
            delete request.type;
            taintedImageBase64Callback[sender.tab.id] = {
                callback: sendResponse
            };
            return true
        } else if (request.type == "setTaintedImageBase64") {
            delete request.type;
            if (typeof taintedImageBase64Callback[sender.tab.id] != "undefined") {
                taintedImageBase64Callback[sender.tab.id].callback(request.data)
            }
        } else if (request.type == "getTaintedImageBase64UsingBackgroundFrame") {
            delete request.type;
            var iframe = document.createElement("iframe");
            iframe.src = request.img_src;
            iframe.width = "1px";
            iframe.height = "1px";
            iframe.name = request.img_src;
            document.body.appendChild(iframe);
            taintedImageBase64Callback[request.img_src] = {
                callback: sendResponse,
                src: request.img_src
            };
            return true
        } else if (request.type == "setTaintedImageBase64UsingBackgroundFrame") {
            delete request.type;
            if (typeof taintedImageBase64Callback[request.original_url] != "undefined") {
                taintedImageBase64Callback[request.original_url].callback(request.data);
                var allFrames = document.getElementsByTagName("iframe");
                for (var i in allFrames) {
                    if (allFrames[i].src == taintedImageBase64Callback[request.original_url].src) {
                        allFrames[i].parentNode.removeChild(allFrames[i])
                    }
                }
            }
        } else if (request.type == "captureScreen") {
            delete request.type;
            var currentTabCheckInteval = setInterval(function() {
                chrome.tabs.query({
                    active: true
                }, function(tabs) {
                    if (tabs.length) {
                        for (var i in tabs) {
                            if (tabs[i].id == sender.tab.id) {
                                clearInterval(currentTabCheckInteval);
                                setTimeout(function() {
                                    chrome.tabs.captureVisibleTab(sender.tab.windowId, {
                                        format: "png"
                                    }, function(dataUrl) {
                                        sendResponse({
                                            dataUrl: dataUrl
                                        })
                                    })
                                }, 200)
                            }
                        }
                    }
                })
            }, 200);
            return true
        }
    })
})();