setI18nMessagesInHTML();
$("#recaptcha_precache_debug_link").attr("href", chrome.extension.getURL("/recaptcha_precache_debug.html"));
chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.type == "showMessage") {
        delete request.type;
        if (request.method && request.method.match(/(show|refresh)[a-z]+Message/i) && typeof window[request.method] == "function") {
            if (typeof request.arguments != "undefined" && Array.isArray(request.arguments)) {
                window[request.method].apply(null, request.arguments)
            } else {
                window[request.method]()
            }
        }
    }
});
initFieldsUsingGlobalStatusValues();
updateFieldsAvailability(chrome.extension.getBackgroundPage().globalStatus.enable);
updateRecaptchaPrecacheFieldsAvailability(chrome.extension.getBackgroundPage().globalStatus.use_recaptcha_precaching);
updateRecaptcha2FieldsAvailability(chrome.extension.getBackgroundPage().globalStatus.solve_recaptcha2);
initFieldsAction();
chrome.extension.getBackgroundPage().getAndRefreshAntigateBalance();
jQuery.fn.clickToggle = function(a, b) {
    function cb() {
        [b, a][this._tog ^= 1].call(this)
    }
    return this.on("click", cb)
};
$(".advanced_settings_button").clickToggle(function() {
    $(".advanced_settings_container").slideDown(500);
    $(".advanced_settings_container").find("label").first().focus()
}, function() {
    $(".advanced_settings_container").slideUp(500)
});
initNewVersionMessage();

function initFieldsUsingGlobalStatusValues() {
    $("input[name=enable]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.enable);
    $("input[name=account_key]").val(chrome.extension.getBackgroundPage().globalStatus.account_key);
    $("input[name=auto_submit_form]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.auto_submit_form);
    $("input[name=use_recaptcha_precaching]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.use_recaptcha_precaching);
    $("input[name=k_precached_solution_count_min]").val(chrome.extension.getBackgroundPage().globalStatus.k_precached_solution_count_min);
    $("input[name=k_precached_solution_count_max]").val(chrome.extension.getBackgroundPage().globalStatus.k_precached_solution_count_max);
    precachedSolutionMinMaxRefresh();
    $("input[name=solve_recaptcha2]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.solve_recaptcha2);
    $("input[name=dont_reuse_recaptcha_solution]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.dont_reuse_recaptcha_solution);
    $("input[name=solve_funcaptcha]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.solve_funcaptcha);
    $("input[name=start_recaptcha2_solving_when_challenge_shown]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.start_recaptcha2_solving_when_challenge_shown);
    $("input[name=solve_only_presented_recaptcha2]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.solve_only_presented_recaptcha2);
    $("input[name=use_predefined_image_captcha_marks]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.use_predefined_image_captcha_marks);
    $("input[name=reenable_contextmenu]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.reenable_contextmenu);
    $("input[name=play_sounds]").attr("checked", chrome.extension.getBackgroundPage().globalStatus.play_sounds)
}

function initFieldsAction() {
    $("#save").click(function() {
        showErrorMessage("");
        showBalanceMessage("");
        var enable = $("input[name=enable]")[0].checked;
        var auto_submit_form = $("input[name=auto_submit_form]")[0].checked;
        var use_recaptcha_precaching = $("#use_recaptcha_precaching")[0].checked;
        var k_precached_solution_count_min = $("#k_precached_solution_count_min").val();
        var k_precached_solution_count_max = $("#k_precached_solution_count_max").val();
        var solve_recaptcha2 = $("input[name=solve_recaptcha2]")[0].checked;
        var dont_reuse_recaptcha_solution = $("input[name=dont_reuse_recaptcha_solution]")[0].checked;
        var solve_funcaptcha = $("input[name=solve_funcaptcha]")[0].checked;
        var start_recaptcha2_solving_when_challenge_shown = $("input[name=start_recaptcha2_solving_when_challenge_shown]")[0].checked;
        var solve_only_presented_recaptcha2 = $("input[name=solve_only_presented_recaptcha2]")[0].checked;
        var use_predefined_image_captcha_marks = $("input[name=use_predefined_image_captcha_marks]")[0].checked;
        var reenable_contextmenu = $("input[name=reenable_contextmenu]")[0].checked;
        var play_sounds = $("input[name=play_sounds]")[0].checked;
        var account_key = $("input[name=account_key]").val();
        k_precached_solution_count_min = Math.max(0, k_precached_solution_count_min);
        k_precached_solution_count_max = Math.max(0, k_precached_solution_count_max);
        chrome.extension.getBackgroundPage().saveOptions({
            enable: enable,
            auto_submit_form: auto_submit_form,
            use_recaptcha_precaching: use_recaptcha_precaching,
            k_precached_solution_count_min: k_precached_solution_count_min,
            k_precached_solution_count_max: k_precached_solution_count_max,
            solve_recaptcha2: solve_recaptcha2,
            dont_reuse_recaptcha_solution: dont_reuse_recaptcha_solution,
            solve_funcaptcha: solve_funcaptcha,
            start_recaptcha2_solving_when_challenge_shown: start_recaptcha2_solving_when_challenge_shown,
            solve_only_presented_recaptcha2: solve_only_presented_recaptcha2,
            use_predefined_image_captcha_marks: use_predefined_image_captcha_marks,
            reenable_contextmenu: reenable_contextmenu,
            play_sounds: play_sounds,
            account_key: account_key
        }, function() {
            showStatusMessage(chrome.i18n.getMessage("optionsSaved"))
        })
    });
    $("input[name=enable]").click(function() {
        updateFieldsAvailability(this.checked)
    });
    $("input[name=use_recaptcha_precaching]").click(function() {
        updateRecaptchaPrecacheFieldsAvailability(this.checked)
    });
    $("input[name=solve_recaptcha2]").click(function() {
        updateRecaptcha2FieldsAvailability(this.checked)
    });
    $("#k_precached_solution_count_min").on("input", function(e) {
        precachedSolutionMinMaxRefresh()
    });
    $("#k_precached_solution_count_max").on("input", function(e) {
        precachedSolutionMinMaxRefresh()
    });
    $("div.no_key_info > span").click(function() {
        $(this.parentNode).toggleClass("expanded")
    });
    $("div.no_key_info > div > span").click(function() {
        $(this.parentNode.parentNode).removeClass("expanded")
    })
}

function updateFieldsAvailability(enable) {
    $("input[name=account_key]").attr("disabled", !enable);
    $("input[name=auto_submit_form]").attr("disabled", !enable);
    $("input[name=use_recaptcha_precaching]").attr("disabled", !enable);
    $("input[name=k_precached_solution_count_min]").attr("disabled", !enable);
    $("input[name=k_precached_solution_count_max]").attr("disabled", !enable);
    $("input[name=solve_recaptcha2]").attr("disabled", !enable);
    $("input[name=dont_reuse_recaptcha_solution]").attr("disabled", !enable);
    $("input[name=solve_funcaptcha]").attr("disabled", !enable);
    $("input[name=start_recaptcha2_solving_when_challenge_shown]").attr("disabled", !enable);
    $("input[name=solve_only_presented_recaptcha2]").attr("disabled", !enable);
    $("input[name=use_predefined_image_captcha_marks]").attr("disabled", !enable);
    $("input[name=reenable_contextmenu]").attr("disabled", !enable);
    $("input[name=play_sounds]").attr("disabled", !enable)
}

function precachedSolutionMinMaxRefresh() {
    var k_precached_solution_count_min = $("#k_precached_solution_count_min").val();
    var k_precached_solution_count_max = $("#k_precached_solution_count_max").val();
    $("#k_precached_solution_count_min_output").val(k_precached_solution_count_min);
    $("#k_precached_solution_count_max_output").val(k_precached_solution_count_max);
    $("#k_precached_solution_count_min").val(Math.min(k_precached_solution_count_min, k_precached_solution_count_max));
    $("#k_precached_solution_count_max").val(Math.max(k_precached_solution_count_min, k_precached_solution_count_max))
}

function updateRecaptchaPrecacheFieldsAvailability(enable) {
    $("input[name=k_precached_solution_count_min]").attr("disabled", !enable);
    $("input[name=k_precached_solution_count_max]").attr("disabled", !enable)
}

function updateRecaptcha2FieldsAvailability(enable) {}

function showStatusMessage(statusText) {
    if ($.trim(statusText)) {
        playSound("done", chrome.extension.getBackgroundPage().globalStatus)
    }
    $("#status").text(statusText);
    setTimeout(function() {
        $("#status").text("")
    }, 5e3)
}

function showErrorMessage(errorText) {
    if ($.trim(errorText)) {
        playSound("error", chrome.extension.getBackgroundPage().globalStatus)
    }
    $("#error").text(errorText)
}

function showBalanceMessage(balanceText) {
    if (typeof balanceText === "number") {
        balanceText += " $"
    }
    $("#balance").html(balanceText)
}

function refreshFreeAttemptsMessage() {
    if (chrome.extension.getBackgroundPage().globalStatus.profile_user_info == null) {
        return
    }
    var free_attempts_left_count = chrome.extension.getBackgroundPage().globalStatus.free_attempts_left_count;
    if (chrome.extension.getBackgroundPage().globalStatus.profile_user_info) {
        showBalanceMessage(chrome.i18n.getMessage("freeAttemptsLeft", free_attempts_left_count + "") + (!free_attempts_left_count ? chrome.i18n.getMessage("getAZCaptchaKey") : ""))
    } else {
        if (free_attempts_left_count) {
            showBalanceMessage(chrome.i18n.getMessage("getFreeAttempts", free_attempts_left_count + ""))
        } else {}
    }
}

function initNewVersionMessage() {
    var currentVersion = chrome.extension.getBackgroundPage().globalStatus.plugin_version;
    var pluginId = chrome.runtime.id;
    var pluginLastVersionData = chrome.extension.getBackgroundPage().globalStatus.plugin_last_version_data;
    if (!pluginLastVersionData || typeof pluginLastVersionData.version === "undefined") {
        return
    }
    var isOldVersion = currentVersion < pluginLastVersionData.version;
    if (isOldVersion) {
        var isAutoupdatable = pluginId == defaultPluginId || pluginId.indexOf("{") === 0;
        var new_version_message_text;
        if (isAutoupdatable) {
            new_version_message_text = chrome.i18n.getMessage("newVersionCrxAutoupdate")
        } else {
            new_version_message_text = chrome.i18n.getMessage("newVersionZipDownloadLink", pluginLastVersionData.version + "")
        }
        var newVersionWhatsNewIndex = chrome.i18n.getMessage("newVersionWhatsNewIndex");
        if (typeof pluginLastVersionData[newVersionWhatsNewIndex] !== "undefined") {
            new_version_message_text += chrome.i18n.getMessage("newVersionWhatsNew") + " " + pluginLastVersionData[newVersionWhatsNewIndex]
        }
        $("#new_version_message").html(new_version_message_text)
    } else {}
}